/**
 * Copyright 2016 the WHATAP project authors. All rights reserved.
 * Use of this source code is governed by a license that
 * can be found in the LICENSE file.
 */

var CounterTask = require('../counter-task'),
    StatSql = require('../../../stat/stat-sql'),
    conf = require('../../../conf/configure'),
    SecurityMaster = require('../../../net/security-master'),
    TraceContextManager = require('../../../trace/trace-context-manager'),
    MeterActiveX = require('../../meter/meter-activex'),
    ActiveStackPack = require('../../../pack/activestack-pack'),
    ParamPack = require('../../../pack/param-pack'),
    EventPack = require('../../../pack/event-pack'),
    ActiveStackStep = require('../../../step/activestack-step'),
    DataPackSender = require('../../../data/datapack-sender'),
    DataTextAgent = require('../../../data/datatext-agent'),
    EventLevel  = require('../../../data/event-level'),
    MeterUsers = require('../../meter/meter-users'),
    KeyGen = require('../../../util/keygen'),
    TextTypes = require('../../../lang/text-types'),
    ResourceProfile = require('../../../util/resourceprofile'),
    Logger          = require('../../../logger'),
    HashUtil = require('../../../util/hashutil'),
    KubeUtil        = require('../../../util/kube-util'),
    DateUtil        = require('../../../util/dateutil'),
    AwsEcsClientThread = require('./util/awsEcsClientThread'),
    Long = require('long');

function SystemECSTask() {
    CounterTask.call(this);
}

SystemECSTask.prototype = new CounterTask();
SystemECSTask.prototype.constructor = SystemECSTask;
SystemECSTask.prototype.process = function (p) {
    p.cpu_cores = 1;
    p.host_ip = SecurityMaster.IP;

    var ecs = AwsEcsClientThread;
    p.cpu = ecs.cpu * conf.correction_factor_cpu;
    p.cpu_sys = ecs.cpu_sys;
    p.cpu_usr = ecs.cpu_user;
    p.mem = ecs.mem_pct;

    if (ecs.millicore > 0) {
        p.metering = ecs.millicore /1024;
    } else {
        p.metering = p.cpu_cores;
    }

};

module.exports = SystemECSTask;