/**
 * Copyright 2016 the WHATAP project authors. All rights reserved.
 * Use of this source code is governed by a license that
 * can be found in the LICENSE file.
 */

var TraceContextManager = require('../trace/trace-context-manager');

var ProcessObserver = function (agent) {
    this.agent = agent;
    this.packages = ['process'];
};
ProcessObserver.prototype.inject = function (mod, moduleName) {
    var self = this;
    self.agent.aop.before(mod, 'nextTick', function (obj, args) {
        var cached_id = TraceContextManager.getCurrentId();
        self.agent.aop.functionHook(args, -1, function (obj, args) {
            if(cached_id != null) {
                TraceContextManager.resume(cached_id);
                cached_id = null;
            }
        });
    });
};

module.exports.ProcessObserver = ProcessObserver;